	opt so,xr
	page 132,66,3,3

	include 'leonid'

TOP_OF_MEMORY	equ	topmem-$0100  ; bit under the Leonid monitor at $3800

	; Assuming Leonid has done its own initialization and has jumped
	; to user_data, this jumps to the C startup code.

	section	startup
	org 	p:user_code
	jmp	F__start
	endsec


	section	crt0

	org 	y:

; The following varaibles are used for dynamic memory allocation
; __stack_safty: Since dynamic memory and the stack grow towards each other 
; This constant tells brk and sbrk what the minimum amount of space should
; be left between the top of stack during the brk or sbrk call and the end
; of any allocated memory.
; __mem_limit: a constant telling brk and sbrk where the end of available 
; memory is.
; __break: pointer to the next block of memory that can be allocated
; The heap may be moved by changing the initial value of __break.
; This is the base of the heap.
; __y_size: the base of dynamic memory.
; errno: error type: set by some libraries
; __max_signal the last possible signal.

	global	Ferrno
Ferrno		dc	$0

	global F__stack_safety
F__stack_safety	dc	1024

	global F__mem_limit
F__mem_limit	dc	TOP_OF_MEMORY

	global F__break
F__break	dc	TOP_OF_MEMORY

	global F__y_size
F__y_size	dc	DSIZE

	global	F__max_signal
F__max_signal	dc	$3e	; what the quint monitor.


	org	p:

F__start
	global	F__start

;	To change the base of the stack, change the value loaded into the
;	stack pointer here.

        and	#$f3,mr		; turn off ALU scaling
        and	#$bf,ccr	; turn off ALU limiting
	move	y:F__y_size,r6	; initialize the stack pointer
         
	xref    F__init_constructor                 
        jsr     F__init_constructor            

        clr	a
        jsr	$0020		; open the serial port in non-kiss mode
  
	move	#$0,r0		; funny value to terminate a backtrace.
	jsr	Fmain		; run user program

	jsr	Fexit		; when exit ( ) isn't explicitly called,
				; call it.
F__crt0_end
	global	F__crt0_end
	wait			; all done, sit around
	jmp	F__crt0_end	; no other place to go...

	endsec

	section crt0__fp_shift

	org	y:

;
; floating point table setup
;

	global	F__fp_shift
F__fp_shift	dc      $800000,$c00000,$e00000,$f00000,$f80000,$fc0000
		dc      $fe0000,$ff0000,$ff8000,$ffc000,$ffe000,$fff000
		dc      $fff800,$fffc00,$fffe00,$ffff00,$ffff80,$ffffc0
		dc      $ffffe0,$fffff0,$fffff8,$fffffc,$fffffe

	endsec

	section	time_counter

	org	y:
F__time
	global	F__time
	dc	0

	endsec

	section	io_primitives

	org	p:

	nop
F__send
	global	F__send
	rts
	nop

	nop
F__receive
	global	F__receive
	rts
	nop

	endsec

; The following section, dummy_call, is used for doing command-line
; function calls on the ADS and simulator.  If you aren't going to use
; those features, it can be removed.

; The host software puts r0 into y:(r6), and then increments r6.
; Then, the current PC is placed into y:(r6) and again r6 is
; incremented.  The new value of r6 is then moved into r0.  If the
; function that the user is calling from the command line returns a
; structure or union, the size of the structure or union is added to
; r6 (making room for it locally), and the value in r0 is moved into
; a1 (since r0 happened to be pointing to the beginning of this local
; structure).  The arguments to the function are then placed on the
; stack starting at y:(r6), with r6 being incremented accordingly.
; Next, the address of dummy_call is placed into the PC.  The address
; of the target function that is being called is then patched in at
; y:(pc+1) (since the jsr is two words and the second word is the
; destination address).
;
; Following this the device is started and a ``finish'' (essentially)
; is done on dummy_call (which will then call the target function).
; If the function call is interrupted by the host software, the
; ADS/simulator is left in a state where the user can step out of the
; called function (because of the prologue code which is after the jsr
; in dummy_call).
;
; The prologue code decrements r0 to where the return address has been
; stored, moves that return address into ssh, and then decrements r0
; again.  At this point r0 has the address that the old r6 had, so we
; move r0 into r6.  Following that we test a (the return value) and
; then move from y:(r0) into r0, which restores the old r0.  Finally,
; we return to our caller.

	section dummy_call

	org	p:

	global	dummy_call
dummy_call
	jsr	>dummy_call
	move	(r0)-
	move	y:(r0)-,ssh
	move	r0,r6
	tst	a	y:(r0),r0
	rts

	endsec
 
        section init_table
        org p:
        xdef    F__begin_init_table
F__begin_init_table
        dc (-1)
 
        endsec
 
 
        section cinit
        org     p:
        xref  F__begin_init_table
        xdef  F__init_constructor
F__init_constructor   
        clr   a                     
        clr   b
        move  #$ffff,m0
        move  m0,m1
        move  m0,m2
        move  #F__begin_init_table,r0
        move  #(-1),x1
 
_loop
 
; p:(r0)      destination start          
; p:(r0+1)    source start               
; p:(r0+2)    size of source block size  
; p:(r0+3)    size zero initialized block
 
        movem p:(r0)+,b         ; destination start
        move  b1,r1
        cmp   x1,b
        jeq _exit
 
        movem p:(r0)+,r2        ; source start           
        movem p:(r0)+,y0        ; size of expicitly initialized block
        movem p:(r0)+,y1        ; size of zero initialized block
 
        cmp   y0,a              ; (y0 == 0) ?
        jeq   _lab2
 
        do    y0,_lab2
        movem p:(r2)+,x0
        move  x0,y:(r1)+
        nop
_lab2           
        cmp   y1,a              ; (y1 == 0) ?
        jeq   _lab3
 
        do    y1,_lab3
        move  a1,y:(r1)+        ; zeros the uninitialized data memory
_lab3   
        jmp _loop
_exit
        rts                     
 
        endsec
 
