
	section	evmgetc_c

	title 'evmgetc.asm: evmgetc,evmlookc,evmtstc for EVM/Leonid/g56k'
	include 'leonid.asm'

; ********************************************************************
; int evmgetc(void) 
;
; Wait for character from serial port
; ********************************************************************

	org	p:
	global	Fevmgetc
Fevmgetc
        move	#0,n6
	jsr	prolog
	getc		; Use Leonid macro
	move	x0,a    ; C wants return value in A w/ flags set
	tst	a
	jmp	epilog


; ********************************************************************
; int evmlookc(int) 
;
; Look if there are characters waiting at the serial input.
; If arg is non-zero, wait for the given time (in seconds).
; Return -1 for timeout.  See notes in sleep.asm about max timeout value.
; The Leonid macro cannot be called, because it takes a constant parameter.
; ********************************************************************

	org	p:
	global	Fevmlookc
Fevmlookc
        move	#0,n6
	jsr	prolog
	move	#-3,n0
	move y:(r0+n0),a   ; get function's parameter
	tst a
	.if <eq>
	    jsr     <$0024
	.else
	    move a1,x0   ; get function's parameter
	    move #baud,x1
	    mpy x0,x1,a	    ; multiply s by SCI timer rate
	    asr a	    ; integer multiply correction
	    move a0,x0
	    jsr     <$0034
_cwait	    wait
	    jsr     <$0024		    ; check if we have a character available
	    jcc     _cfnd  
	    ; Look at bit #timer of y:flags
	    jset    #4,y:$0003,_cwait	    ; no, are we tired for waiting
	    move    #-1,x0		    ; timeout: return -1
_cfnd	    
	.endi

	move    x0,a    ; C wants return value in A w/ flags set
	tst	a
	jmp	epilog


; ********************************************************************
; int evmtstc(void) 
;
; Return 1 if character waiting at serial port, or 0 if not.
; ********************************************************************

	org	p:
	global	Fevmtstc
Fevmtstc
        move	#0,n6
	jsr	prolog
	tstc		; Use Leonid macro, which returns result in C flag.
	move	#<0,a
	.if <cc>
	    move    #>1,a
	.endi
	tst	a
	jmp	epilog


	endsec

