; $Header: E:/HAM/EVM/TEST/RCS/FIRMACS.ASM 1.3 1997/01/31 09:30:06 dbraun Exp $
; $Log: FIRMACS.ASM $
; Revision 1.3  1997/01/31 09:30:06  dbraun
; Added one more macro definition.
;
; Revision 1.2  1997/01/28 15:56:12  dbraun
; Cleaned up a little
;
; Revision 1.1  1997/01/28 15:48:30  dbraun
; Initial revision
;
;

; Macros to generate various kinds of filter FIR coefficients.
; Gathered together from various 56002 programs.
 

; These are intended to be local to this file...
PI_ = 3.14159265358979323846
EX_ = 2.718281745911


;******************************************************************
; This should have a more descriptive name...

BasicBandpassFilter	macro	Length,LowFreq,UppFreq

sigma = @cvf(Length)/2.0/3.0
time = -@cvf(Length/2)+0.5
count = 0
        dup Length
Window = @pow(EX_,-time*time/(2.0*sigma*sigma))
Filter = (@sin(2.0*PI_*time*UppFreq)-@sin(2.0*PI_*time*LowFreq))/(PI_*time)
time = time+1.0
        dc  Window*Filter
count = count+1
        endm

	endm


;******************************************************************
; A different windowing function

CosineWindowBandpassFilter	macro	Length,LowFreq,UppFreq

time = -@cvf(Length/2)+0.5
count = 0
	dup Length
Window = 0.75*@cos((time/@cvf(Length))*PI_)+0.25*@cos(3*(time/@cvf(Length))*PI_)
Filter = (@sin(2.0*PI_*time*UppFreq)-@sin(2.0*PI_*time*LowFreq))/(PI_*time)
time = time+1.0
	dc Window*Filter
count = count+1
	endm

	endm




w0_      equ    0.35875 ;coeff. for Blackman-Harris 4 term
w1_      equ    0.48829 ;minimum sidelobe window (copied from Motorola BBS)
w2_      equ    0.14128
w3_	equ 	0.01168


;******************************************************************
BlackmanHarrisFilterI	macro	Length,LowFreq,UppFreq

time = -@cvf(Length/2)+0.5
count = 0
        dup Length
angle = PI_*time/@cvf(Length/2)
Window = w0_+w1_*@cos(angle)+w2_*@cos(2.0*angle)+w3_*@cos(3.0*angle)
Filter = (@sin(2.0*PI_*time*UppFreq)-@sin(2.0*PI_*time*LowFreq))/(PI_*time)
time = time+1.0
        dc  Window*Filter
count = count+1
        endm

        endm


;******************************************************************
BlackmanHarrisFilterQ	macro	Length,LowFreq,UppFreq

time = -@cvf(Length/2)+0.5
count = 0
        dup Length
angle = PI_*time/@cvf(Length/2)
Window = w0_+w1_*@cos(angle)+w2_*@cos(2.0*angle)+w3_*@cos(3.0*angle)
Filter = (-@cos(2.0*PI_*time*UppFreq)+@cos(2.0*PI_*time*LowFreq))/(PI_*time)
time = time+1.0
        dc  Window*Filter
count = count+1
        endm

	endm



