/*

  $Header: E:/HAM/EVM/DLIB/RCS/utils.h 1.4 1997/01/13 12:38:21 dbraun Exp $

  $Log: utils.h $
  Revision 1.4  1997/01/13 12:38:21  dbraun
  Fixed up declarations a bit.

  Revision 1.3  1996/12/05 22:24:28  dbraun
  Changed procedure declarations.

  Revision 1.2  1996/10/22 19:35:16  dbraun
  Added stuff to read and store symbol table from .lod files.


*/

/*  UTILS.H -- Header for the utility functions
 *
 *  Copyright (C) by Alef Null 1992-1995
 *  Author(s): Jarkko Vuori, OH2LNS
 *	       Rob Janssen,  PE1CHL
 *  Modification(s):
 */

#define MAX_FILES   2

#ifndef _MAX_PATH
#define _MAX_PATH   1024
#endif

#ifndef max
#define max(a,b)    ((a) > (b) ? (a) : (b))
#endif

typedef enum { True = -1, False = 0 } Bool;

typedef enum {
    p = 0x01,	// bit 0: data/pgm
    x = 0x00,	// bit 1: x/y
    y = 0x02,
    n = 0x03    // Valid only for symbols: numeric value
} DATASPACE;

typedef struct {
    unsigned	year:7;
    unsigned	month:4;
    unsigned	day:5;
} DATE;

typedef enum { Modify, ReadOnly, Last } FileMode;

typedef Bool (cdecl *Operation)(FILE *files[], ...);

typedef struct {
    unsigned char  space;
    unsigned short address,
		   len;
} BLKHEADER;

typedef struct {
    char       cmd;
    Bool       numericArgument, fDescription;
    char      *usage;
    FileMode   fileModes[MAX_FILES+1];
    char      *extension[MAX_FILES];
    Operation  operation;
} CMDS;


typedef struct sym_tab_entry {
    char *name;
    DATASPACE space;
    long value;
    struct sym_tab_entry *next;
} SYM_TAB_ENTRY;


unsigned  crc(unsigned char *blk, unsigned len);
char	 *AddExtension(char *FileName, char *Extension);
char	 *dateStr(DATE date);
int	  ParseCommands(int argc, char *argv[], CMDS *cmds, int cmdcount,
		int defcmd, int desc_len, void (*usage)(void));
Bool	  ReadBlocks(FILE *fp, Bool (*block)(BLKHEADER *pHeader, long huge *data));

SYM_TAB_ENTRY *get_symbol_table(void);
SYM_TAB_ENTRY *findSymbol(char *name);
SYM_TAB_ENTRY *clear_symbol_table(void);
