; $Header: E:/HAM/EVM/TEST/RCS/WESAT2.ASM 1.1 1996/11/30 15:26:58 dbraun Exp $
;
; $Log: WESAT2.ASM $
; Revision 1.1  1996/11/30 15:26:58  dbraun
; Initial revision
;
;

	PAGE 132
;
        ;DB added this for the \.if stuff for the up/down LEDs
        scsjmp short    ;force short jumps for .if/.endi, .while/.endw, etc.

	nolist
	include 'leonid'
	include 'ioequlc'
	include 'intequlc'
	list
	title 'APT WESAT interface for JVFAX'

DCDLED  macro mode      ; DCDLED clr/set/chg
	b\mode #13,X:$FFE4
	endm

UpLED   macro mode      ;UP line (a red LED connected)
        b\mode #1,X:$FFE4
        endm

DownLED macro mode      ;DOWN line (a red LED connected)
        b\mode #2,X:$FFE4
        endm

RxRightChannel equ 0           ; DB: Listen to right channel instead of left.


;-----------------------------------------------------------------------------
; Select EVM clock speed
; Some 66MHz parts will run up to 80 MHz
;
MHZ32   equ	0	; 32 MHz for most accurate SCI baudrates      *JBF*
MHZ40 	equ	0	; 40 MHz EVM				      *JBF*
MHZ66	equ	1	; 66 MHz EVM				      *JBF*
MHZ80   equ	0	; 80 MHz EVM				      *JBF*
	if EVM56K	   ;					      *JBF*
	if	MHZ32	   ;					      *JBF*
Xtal	equ	32000000   ;					      *JBF*
	endif		   ;					      *JBF*
	if	MHZ40	   ;					      *JBF*
Xtal	equ	40000000   ;					      *JBF*
	endif		   ;					      *JBF*
	if	MHZ66	   ;					      *JBF*
Xtal	equ	68000000   ;					      *JBF*
	endif		   ;					      *JBF*
	if	MHZ80	   ;					      *JBF*
Xtal	equ	80000000   ;					      *JBF*
	endif		   ;					      *JBF*
	else
Xtal            equ 27000000    ;DSP's crystal frequency for DSPCARD4
	endif

SampleFreq      equ 9600.0

PassFilterLen    equ 64
PassFilterCenter equ 2400.0 ;APT subcarrier frequency
PassFilterWidth equ 2000.0  ;consult clever books...

CarFreq         equ 2400.0  
CarDev          equ 400.0   ;FAX deviation for standard shortwave FAX

RxOutScale      equ 2.00    ;this factor gives about full swing between 0 and 255
			    ;on output for a deviation = +/-CarDev

BitFilterLen    equ 2       ;longer post-detection filter => less noise
			    ;but the picture gets smeared out more.

NewBaudRate     equ 57600   ;FAX needs lot of pixels/second thus we need
			    ;this high speed on the serial port

BufLen  equ  PassFilterLen+32      ;sample buffer length

BatchLen equ     2      ;processing batch length
BatchLenLog equ  0      ;BatchLen = 2 ^ BatchLenLog

InpGain    equ 9.0     ;Initial CODEC input gain in dB's

SPY     equ 0   

  if SPY
SPYdata     equ 1           ;for spying on the demodulator output
SPYampl     equ 0           ;for spying on the demodulator output
SPYinput     equ 0
  else
SPYdata     equ 0
SPYampl     equ 0
SPYinput    equ 0
  endif


	LOMEM P:$0000
	HIMEM P:$1FFF

	org p:user_code

	move #Buffer,r2          ;for us to address the input and output samples
	move #<4,n2
	move #BufLen*4-1,m2

	move #RxBitFilterTap,r6
	move #BitFilterLen-1,m6

	move #Buffer+2,r7        ;r7 for the CODEC's interrupt routine
	move #BufLen*4-1,m7

; N1OWU:  Activate the relay that switches the analog I/O
; to the 9600 baud FSK port.  It's connected to bit 9 of port B.
; This is correct for the IC-821 setup.  It causes the EVM
; to get the radio's data output, not the audio output. 

	bset	#9,x:$ffe4 


			;initialize input/output control words in the buffer
			;zero input/output data
      if EVM56K ;for the EVM56002 use the microphone input
	ctrlcd  1,r2,BufLen,MIC,InpGain,InpGain,LINEO|HEADP,94.5,94.5
      else      ;for the DSPCARD4 use the LINE input
	ctrlcd  1,r2,BufLen,LINEI,InpGain,InpGain,LINEO|HEADP,94.5,94.5
      endif
	opencd SampleFreq/1000.0,HPF    ;start taking samples at given rate
;
; Changed order of CODEC buffer initialization and SCI baudrate setup *JBF*
;
	if !SPY								  
	  bclr #12,X:<<$FFF0    ;disable SCI Tx interrupts		  
	  bclr #11,X:<<$FFF0    ;disable SCI Rx interrupts		  
	  if NewBaudRate        ;set new baud rate (copied from LEONID)	  
	   jclr #0,X:<<$FFF1,*  ;wait until all data is sent out	  
	   movep #(Xtal+2*16*NewBaudRate)/(2*2*16*NewBaudRate)-1,X:<<$FFF2
	  endif								  
	endif								  


BatchLoop
	waitblk r2,BufLen,BatchLen      ;wait till enough samples for one batch
					;the following code should use r2
					;for addressing the samples
					;r7,m7 must not be used: SSI interrupts
					;r3,m3 must not be used: SCI interrupts and LEONID code

 	  if RxRightChannel 
	    move	(r2)+           ;DB: Switch to right channel samples
	  endif

	  move	#BitFilterCoeffs,r4
	  move	(r2)-n2
	  move	(r2)-n2		; Move back two samples

	  ; Filter the magnitudes of the samepls

	  clr a X:(r2)+n2,x0 Y:(r4)+,y0
	  .loop #4-1
	    move x0,b
	    abs b
	    move b,x0
	    mac x0,y0,a X:(r2)+n2,x0  Y:(r4)+,y0
	  .endl
	  move x0,b
	  abs b
	  move b,x0
	  macr x0,y0,a

	  ; R2 is left pointing two samples ahead


	  if RxRightChannel 
	    move	(r2)-   ;DB: Switch back to left channel.
	  endif

	if SPYampl
	  jsr <SpyA
        endif

	  move a,y0             ;scale the output data
	  move #>RxOutScale/32768.0,x0
	  mpyr x0,y0,a
	  move #>0,x0 ;limit the data to 0..$FF range
	  tlt x0,a
	  move #>$FF,x0
	  cmp x0,a
	  tgt x0,a

	  if SPYdata
	    jsr <SpyA
          endif

	  ; DB: If the data value is close to zero (black), turn on
	  ; the "down" LED.  If it is close to 255 (white), turn on
	  ; the "up" LED.  Otherwise, turn both LEDs off.

	  move #>$40,x0
	  cmp x0,a
	  .if <le>
	    DownLED set
	  .else
	    move #>$C0,x0
	    cmp x0,a
	    .if <ge>
	      UpLED set
	    .else
	      DownLED clr
	      UpLED clr
	    .endi
	  .endi
	    
	if !SPY
	  jclr #m_tdre,X:<<m_ssr,RxData_end  ;serial Tx empty ?
	  movep a1,X:<<m_stxl    ;output the data to the serial port
RxData_end

        endif   ;Spy

	jmp     <BatchLoop

PI      equ     3.14159265358979323846
EX      equ     2.718281745911

;this routine computes a cosine/sine pair using the sine ROM
;with a second order (linear+quadrature) approximation between table points
IQ                              ;x0 = angle ( -1 = -PI, +1 = +PI)
	move #>$80,x1   ;shift out 8 most significant bits
	mpy x0,x1,a  #>$FF,x0
	ori #%00000011,mr       ;disable interrupts
	move x0,m0
	and x0,a     #>$100,x0
	or x0,a      #<$40,n0
	ori #%00000100,omr      ;enable the sine ROM table
	move a1,r0      ;put the 8 most significant bits into r0 with offset = $100
	move a0,y0      ;save the remaining bits in y0
	jclr #23,y0,SinTable
	  move (r0)+
SinTable
	move Y:(r0+n0),x0       ;x0 = coarse cosine
	move Y:(r0),x1          ;x1 = coarse sine
	mpyr x1,y0,a  #PI/256.0,y1
	tfr x0,a  a,x1
	macr -x1,y1,a           ;a = fine cosine
	mpyr x0,y0,b  Y:(r0),x1
	andi #%11111011,omr     ;disable the sine ROM table
	tfr x1,b  b,x1
	macr x1,y1,b  #PI*PI/2.0/65536.0,y1  ;b = fine sine
	mpyr y0,y0,a  a,x0
	andi #%11111100,mr      ;enable interrupts
	move a,y0
	mpyr y0,y1,a
	tfr x0,a  a,y1
	macr -x0,y1,a  b,x1     ;a = super fine cosine
	macr -x1,y1,b           ;b = super fine sine
	rts                     ;x,y are modified
				;r0,m0,n0 are modified
				;maximum error is about 0.7E-6
				;execution time 4+64+4 clock cycles
				;including "jsr <IQ" and "rts"
;enable/disable interrupts must be there if interrupt routines
;are accesing RAM at Y:$100..$1FF (like CODEC input/output buffers)


; Square Root by Polynomial Approximation, 7-bit Accuracy.
; From Motorola 
;
sqrt1
;       Does a square root by polynomial aproximation, 7 bit accuracy.
;       sqrt(x)=-.2831102*x*x+2*.5031642*x+.272661
;                  a2             a1          a0
;       valid for:  .25<= x < 1.0
;
;       input value in x0, output in register A.
;
	move x1,Y:<SqrtSave
	move y0,Y:<SqrtSave+1

        mpyr    x0,x0,a  y:<SqrtCoeffs,y0 ;x**2, get a1
        mpy     x0,y0,a  a,x1           ;x*a1, save x**2
        mac     x0,y0,a  y:<SqrtCoeffs+1,y0     ;2*x*a1, get a2
        macr    x1,y0,a  y:<SqrtCoeffs+2,y0     ;a2* x**2, get a0
        add     y0,a                    ;add in a0

	move Y:<SqrtSave,x1
	move Y:<SqrtSave+2,y0

        rts


	if SPY

SpyA    move a10,L:<SpySave
	move a2,X:<SpySave+1
	move x0,Y:<SpySave+1
	move x1,Y:<SpyCount
	move X:<SpyCount,a
	tst a
	jne <Spy_copy

Spy_check
	lookc 0
	jcs <Spy_end
	move #>'S',a
	cmp x0,a
	jne <Spy_end
	move #>'P',x0
	putc
	move #>0,x0
	putc
	move #>512,a
Spy_copy
	move #>1,x0
	sub x0,a
	move a,X:<SpyCount

	move X:<SpySave,a
	rep     #8
	lsr     a
	move    a1,x0
	putc
	move X:<SpySave,a
	rep     #16
	lsr     a
	move    a1,x0
	putc

Spy_end move L:<SpySave,a10
	move X:<SpySave+1,a2
	move Y:<SpySave+1,x0
	move Y:<SpyCount,x1
	rts

	endif

;Internal RAM allocations

	LOMEM X:$0000,Y:$0000,L:$0000
	HIMEM X:$00FF,Y:$00FF,L:$00FF

	org L:user_data

	if SPY
SpySave dc 0,0
SpyCount dc 0
	endif

LastL = *

	org X:LastL
	org Y:LastL

	org X:
RxCarFreq   dc 2*CarFreq/SampleFreq
RxCarPhase  dc 0
RxCarI dc 0     ;cos/sin of RxCarPhase
RxCarQ dc 0
RxI    dc 0     ;most recent I-Q vector
RxQ    dc 0

	org Y:

SqrtSave
	dc  0,0,0,0
SqrtCoeffs
	dc  .5031642,-.2831102,.272661   ; a1, a2, a0


;External RAM allocations

	if EVM56K
	  LOMEM X:$2000,Y:$0100,L:$2000
	  HIMEM X:$3FFF,Y:$3FFF,L:$3FFF
	else
	  LOMEM X:$0100,Y:$0100,L:$0100
	  HIMEM X:$1FFF,Y:$3FFF,L:$1FFF
	endif

	if EVM56K
	  org L:$2000
	else
	  org L:$200
	endif
Buffer   dsm BufLen*4   ;CODEC's input/output buffer

LastL = *
	org X:LastL
	org Y:LastL

	org Y:
PassFilterI dsm PassFilterLen ;anti-alias input filter (I and Q)
PassFilterQ dsm PassFilterLen

	org X:
PassFilterOut dsm PassFilterLen

	org X:
RxBitFilter dsm BitFilterLen
TxBitFilter dsm BitFilterLen

	org Y:
RxBitFilterTap dsm BitFilterLen
TxBitFilterTap dsm BitFilterLen
BitFilterCoeffs dc 0.1,0.4,0.4,0.1


LowFreq = (PassFilterCenter-PassFilterWidth/2)/SampleFreq
UppFreq = (PassFilterCenter+PassFilterWidth/2)/SampleFreq

	org Y:PassFilterI

time = -@cvf(PassFilterLen/2)+0.5
count   set 0
	dup PassFilterLen
Window = 0.75*@cos((time/@cvf(PassFilterLen))*PI)+0.25*@cos(3*(time/@cvf(PassFilterLen))*PI)
Filter = (@sin(2.0*PI*time*UppFreq)-@sin(2.0*PI*time*LowFreq))/(PI*time)
time = time+1.0
	dc Window*Filter
count   set count+1
	endm

	org Y:PassFilterQ

time = -@cvf(PassFilterLen/2)+0.5
count   set 0
	dup PassFilterLen
Window = 0.75*@cos((time/@cvf(PassFilterLen))*PI)+0.25*@cos(3*(time/@cvf(PassFilterLen))*PI)
Filter = (@cos(2.0*PI*time*UppFreq)-@cos(2.0*PI*time*LowFreq))/(PI*time)
time = time+1.0
	dc Window*Filter
count   set count+1
	endm

	org X:PassFilterOut

time = -@cvf(PassFilterLen/2)+0.5
count   set 0
	dup PassFilterLen
Window = 0.75*@cos((time/@cvf(PassFilterLen))*PI)+0.25*@cos(3*(time/@cvf(PassFilterLen))*PI)
Filter = (@sin(2.0*PI*time*UppFreq)-@sin(2.0*PI*time*LowFreq))/(PI*time)
time = time+1.0
	dc  Window*Filter
count   set count+1
	endm

	org X:RxBitFilter

;sigma = @cvf(BitFilterLen)/2.0/6.0

time = -@cvf(BitFilterLen/2)+0.5
count   set 0
	dup BitFilterLen
Filter = 0.75*@cos(PI*time/@cvf(BitFilterLen))+0.25*@cos(3*PI*time/@cvf(BitFilterLen))
;Filter = @pow(EX,-time*time/(2.0*sigma*sigma))
time = time+1.0
	dc Filter/(BitFilterLen)*(SampleFreq/2.0/CarDev)/8.0
count   set count+1
	endm

	org X:TxBitFilter

time = -@cvf(BitFilterLen/2)+0.5
count   set 0
	dup BitFilterLen
Filter = 0.75*@cos(PI*time/@cvf(BitFilterLen))+0.25*@cos(3*PI*time/@cvf(BitFilterLen))
time = time+1.0
	dc  Filter/(BitFilterLen/2)
count   set count+1
	endm

	end



