; $Header: E:/HAM/EVM/TEST/RCS/WESAT3.ASM 1.2 1997/01/28 23:08:36 dbraun Exp $
;
; $Log: WESAT3.ASM $
; Revision 1.2  1997/01/28 23:08:36  dbraun
; Look at peak instead of average noise amplitude.
;
; Revision 1.1  1996/12/03 13:34:25  dbraun
; Initial revision
;
;

	PAGE 132
;
        ;DB added this for the \.if stuff for the up/down LEDs
        scsjmp short    ;force short jumps for .if/.endi, .while/.endw, etc.

	opt mex,cex
	opt si	; prevents incorrect short immediates to fractional registers
	nolist
	include 'leonid'
	include 'ioequlc'
	include 'intequlc'
	list
	title 'APT WESAT interface for JVFAX'

DCDLED  macro mode      ; DCDLED clr/set/chg
	b\mode #13,X:$FFE4
	endm

UpLED   macro mode      ;UP line (a red LED connected)
        b\mode #1,X:$FFE4
        endm

DownLED macro mode      ;DOWN line (a red LED connected)
        b\mode #2,X:$FFE4
        endm

RxRightChannel equ 0           ; DB: Listen to right channel instead of left.


SampleFreq      equ 48000.0
CarFreq         equ 2400.0  
SamplesPerBit   equ 10
BitFreq		equ SampleFreq/SamplesPerBit

SignalFilterLen    equ 64
SignalFilterCenter equ CarFreq
SignalFilterWidth equ 2400.0

NoiseFilterLen    equ 64
NoiseFilterCutoff equ 8000.0   ;cutoff for high-pass filter

BitFilterLen	equ 16
BitFilterCutoff equ BitFreq/2.0   ;cutoff for low-pass filter

AmplitudeBufferLen equ @cvi(@max(BitFilterLen,SamplesPerBit))


InpGain    equ 9.0	;CODEC input gain in dB
			;Changing this affects other parameters!

; RxOutScale Needs to be tuned to adjust contrast 
RxOutScale      equ 3.00   ; OK for METOER sats
;RxOutScale      equ 2.00    ; OK for NOAA sats

NoiseThreshold equ 0.155     ; Needs to be tuned by trial and error (was .125)


NewBaudRate     equ 57600   ;FAX needs lot of pixels/second thus we need
			    ;this high speed on the serial port

BufLen  equ  @cvi(@max(SignalFilterLen,NoiseFilterLen))+32  ;sample buffer length


SPY     equ 1   

  if SPY
SPYinput     equ 0
SPYsignal     equ 0    
SPYnoise     equ 0    
SPYsignalAmpl     equ 0
SPYnoiseAmpl     equ 1
SPYdata     equ 0    
  else
SPYinput    equ 0
SPYsignal    equ 0
SPYnoise     equ 0
SPYsignalAmpl    equ 0
SPYnoiseAmpl     equ 0
SPYdata     equ 0
  endif


	LOMEM P:$0000
	HIMEM P:$1FFF

	org p:user_code

; Set up correct baud rate.
; Note: xtal is defined in leonid.asm

	if !SPY								  
	  bclr #12,X:<<$FFF0    ;disable SCI Tx interrupts		  
	  if NewBaudRate        ;set new baud rate (copied from LEONID)	  
	   bclr #11,X:<<$FFF0    ;disable SCI Rx interrupts		  
	   jclr #0,X:<<$FFF1,*  ;wait until all data is sent out	  
	   movep #(xtal+2*16*NewBaudRate)/(2*2*16*NewBaudRate)-1,X:<<$FFF2
	   bset #11,X:<<$FFF0    ;re-enable only SCI Rx interrupts		  
	  endif								  
	endif								  


; Register Usage:

;r2, n2, m2 are for addressing the sample buffer.
;r7, m7 must not be used: SSI interrupts
;r3, m3 must not be used: SCI interrupts and LEONID code

; generally:
; r0, m0, n0 point to data during filtering MACs
; r4 points to filter coeffs during filtering MACs.  (m4,n4 not necessary)

; r5, m5 are signal amplitudes
; r6, m6 are noise amplitudes

	move #Buffer,r2          ;for us to address the input and output samples
	move #<4,n2
	move #BufLen*4-1,m2

	move #Buffer+2,r7        ;r7 for the CODEC's interrupt routine
	move #BufLen*4-1,m7

	move #SignalAmplitudeBuffer,r5
	move #AmplitudeBufferLen-1,m5

	move #NoiseAmplitudeBuffer,r6
	move #AmplitudeBufferLen-1,m6

; N1OWU:  Activate the relay that switches the analog I/O
; to the 9600 baud FSK port.  It's connected to bit 9 of port B.
; This is correct for the IC-821 setup.  It causes the EVM
; to get the radio's data output, not the audio output. 

      bset	#9,x:$ffe4 


			;initialize input/output control words in the buffer
			;zero input/output data
      if EVM56K ;for the EVM56002 use the microphone input
	ctrlcd  1,r2,BufLen,MIC,InpGain,InpGain,LINEO|HEADP,94.5,94.5
      else      ;for the DSPCARD4 use the LINE input
	ctrlcd  1,r2,BufLen,LINEI,InpGain,InpGain,LINEO|HEADP,94.5,94.5
      endif

      opencd SampleFreq/1000.0,HPF    ;start taking samples at given rate


BatchLoop
	waitblk r2,BufLen,SamplesPerBit             ;wait for a sample


	.loop #SamplesPerBit

 	  if RxRightChannel 
	    move	(r2)+           ;DB: Switch to right channel samples
	  endif

	  if SPYinput
	    move X:(r2),a
	    jsr <SpyA
          endif

	  ; Filter with both the signal and noise filters
	  move #BufLen*4-1,m0
	  move #<4,n0

	  move #SignalFilter,r4
	  move r2,r0
	  nop

	  clr a X:(r0)+n0,x0 Y:(r4)+,y0
	  .loop #SignalFilterLen-1
	    mac x0,y0,a X:(r0)+n0,x0  Y:(r4)+,y0
	  .endl
	  mac x0,y0,a 

	  if SPYsignal
	    jsr <SpyA
          endif

	  ;Store signal magnitude in buffer
	  abs a
	  move a,X:(r5)+

	  move #NoiseFilter,r4
	  move r2,r0
	  nop

	  clr a X:(r0)+n0,x0 Y:(r4)+,y0
	  .loop #NoiseFilterLen-1
	    mac x0,y0,a X:(r0)+n0,x0  Y:(r4)+,y0
	  .endl
	  mac x0,y0,a

	  if SPYnoise
	    jsr <SpyA
          endif

	  ;Store noise magnitude in buffer
	  abs a
	  move a,X:(r6)+

	  if RxRightChannel 
	    move	(r2)-   ;DB: Switch back to left channel.
	  endif

	  move	(r2)+n2

	.endl


	; Find the peak value of the noise

	  move m6,m0
	  move r6,r0
	  nop
	  move (r0)-   ; r0/m0 points to most recent amplitude sample

	  clr a  X:(r0)-,x0
	  .loop #BitFilterLen
	    cmp x0,a
	    tlt x0,a
	    move X:(r0)-,x0
	  .endl

	  ; a has the peak value

	  if SPYnoiseAmpl
	    jsr <SpyA
          endif

          ; If the peak noise is greater than the threshold, substitute
          ; a constant large value for the signal.

	  move X:<noise,x0
	  cmp x0,a
	  jle NoSignalOverload 

	  ; Skip the analysis of the signal
	  move #0.9,a
	  UpLED set
	  jmp SignalOverload

NoSignalOverload
	  UpLED clr
	  ; Low-pass filter the signal
	  move m5,m0
	  move r5,r0
	  move #BitFilter,r4
	  move (r0)-   ; r0/m0 points to most recent amplitude sample
	  nop

	  clr a  X:(r0)-,x0 Y:(r4)+,y0
	  .loop #BitFilterLen-1
	    mac x0,y0,a X:(r0)-,x0 Y:(r4)+,y0
	  .endl
	  macr x0,y0,a          ;a=filtered data

	  if SPYsignalAmpl
	    jsr <SpyA
          endif

SignalOverload
	  if SPYdata
	    jsr <SpyA
          endif

	  move a,y0             ;scale the output data
	  move #RxOutScale/32768.0,x0
	  mpyr x0,y0,a

	  move #>0,x0 ;limit the data to 0..$FF range
	  tlt x0,a
	  move #>$FF,x0
	  cmp x0,a
	  tgt x0,a


	  ; DB: If the data value is close to zero (black), turn on
	  ; the "down" LED.  If it is close to 255 (white), turn on
	  ; the "up" LED.  Otherwise, turn both LEDs off.

	  move #>$40,x0
	  cmp x0,a
	  .if <le>
	    DownLED set
	    DCDLED clr
	  .else
	    DownLED clr
	    move #>$C0,x0
	    cmp x0,a
	    .if <ge>
	      DCDLED set
	    .else
	      DCDLED clr
	    .endi
	  .endi
	    
	if !SPY
	  jclr #m_tdre,X:<<m_ssr,RxData_end  ;serial Tx empty ?  Has to be...
	  movep a1,X:<<m_stxl    ;output the data to the serial port
RxData_end
        endif   ;Spy

	jmp     <BatchLoop



	if SPY

SpyA    move a10,L:<SpySave
	move a2,X:<SpySave+1
	move x0,Y:<SpySave+1
	move x1,Y:<SpyCount
	move X:<SpyCount,a
	tst a
	jne <Spy_copy

Spy_check
	lookc 0
	jcs <Spy_end
	move #>'S',a
	cmp x0,a
	jne <Spy_end
	move #>'P',x0
	putc
	move #>0,x0
	putc
	move #>512,a
Spy_copy
	move #>1,x0
	sub x0,a
	move a,X:<SpyCount

	move X:<SpySave,a
	rep     #8
	lsr     a
	move    a1,x0
	putc
	move X:<SpySave,a
	rep     #16
	lsr     a
	move    a1,x0
	putc

Spy_end move L:<SpySave,a10
	move X:<SpySave+1,a2
	move Y:<SpySave+1,x0
	move Y:<SpyCount,x1
	rts

	endif

;Internal RAM allocations

	LOMEM X:$0000,Y:$0000,L:$0000
	HIMEM X:$00FF,Y:$00FF,L:$00FF

	org L:user_data

	if SPY
SpySave dc 0,0
SpyCount dc 0
	endif

LastL = *

	org X:LastL
	org Y:LastL

	org X:

noise	dc NoiseThreshold

;External RAM allocations

	if EVM56K
	  LOMEM X:$2000,Y:$0100,L:$2000
	  HIMEM X:$3FFF,Y:$3FFF,L:$3FFF
	else
	  LOMEM X:$0100,Y:$0100,L:$0100
	  HIMEM X:$1FFF,Y:$3FFF,L:$1FFF
	endif

	if EVM56K
	  org L:$2000
	else
	  org L:$200
	endif
Buffer   dsm BufLen*4   ;CODEC's input/output buffer

LastL = *
	org X:LastL
	org Y:LastL


PI      equ     3.14159265358979323846
EX      equ     2.718281745911

	org Y:
SignalFilter dsm SignalFilterLen   
NoiseFilter dsm NoiseFilterLen

	org X:
SignalAmplitudeBuffer dsm AmplitudeBufferLen
NoiseAmplitudeBuffer dsm AmplitudeBufferLen

	org Y:
BitFilter dsm BitFilterLen



LowFreq = (SignalFilterCenter-SignalFilterWidth/2)/SampleFreq
UppFreq = (SignalFilterCenter+SignalFilterWidth/2)/SampleFreq

	org Y:SignalFilter

time = -@cvf(SignalFilterLen/2)+0.5
count   set 0
	dup SignalFilterLen
Window = 0.75*@cos((time/@cvf(SignalFilterLen))*PI)+0.25*@cos(3*(time/@cvf(SignalFilterLen))*PI)
Filter = (@sin(2.0*PI*time*UppFreq)-@sin(2.0*PI*time*LowFreq))/(PI*time)
time = time+1.0
	dc Window*Filter
count   set count+1
	endm



LowFreq = NoiseFilterCutoff/SampleFreq
UppFreq = 0.5   ; This makes it a high-pass filter

	org Y:NoiseFilter

time = -@cvf(NoiseFilterLen/2)+0.5
count   set 0
	dup NoiseFilterLen
Window = 0.75*@cos((time/@cvf(NoiseFilterLen))*PI)+0.25*@cos(3*(time/@cvf(NoiseFilterLen))*PI)
Filter = (@sin(2.0*PI*time*UppFreq)-@sin(2.0*PI*time*LowFreq))/(PI*time)
time = time+1.0
	dc Window*Filter
count   set count+1
	endm


UppFreq = BitFilterCutoff/SampleFreq

	org Y:BitFilter

time = -@cvf(BitFilterLen/2)+0.5
count   set 0
	dup BitFilterLen
Window = 0.75*@cos(PI*time/@cvf(BitFilterLen))+0.25*@cos(3*PI*time/@cvf(BitFilterLen))
Filter = @sin(2.0*PI*time*UppFreq)/(PI*time)
time = time+1.0
	dc Window*Filter
count   set count+1
	endm


